commit 30f07ff6899b8146df4d5f362ee8e97675dfc6d1
Author: freddy77 <freddy77>
Date:   Fri Feb 27 10:11:42 2009 +0000

    fix nasty problem under HP-UX

diff --git a/ChangeLog b/ChangeLog
index 1d44bfc..4ced9a7 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Fri Feb 27 11:11:32 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* configure.ac include/tds_sysdep_private.h:
+	* src/odbc/unittests/freeclose.c src/odbc/unittests/timeout3.c:
+	* src/pool/user.c src/server/login.c src/tds/net.c:
+	- fix nasty problem under HP-UX
+
 Fri Feb 27 11:07:20 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/log.c src/tds/query.c: fix possible format problems
 
@@ -1317,4 +1323,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2730 2009/02/27 10:07:34 freddy77 Exp $
+$Id: ChangeLog,v 1.2731 2009/02/27 10:11:42 freddy77 Exp $
diff --git a/configure.ac b/configure.ac
index f399bfe..a705473 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1,7 +1,7 @@
 dnl Process this file with autoconf to produce a configure script.
 
 dnl ------------------------------------------------------------
-dnl $Id: configure.ac,v 1.39 2009/02/26 19:04:10 freddy77 Exp $
+dnl $Id: configure.ac,v 1.40 2009/02/27 10:11:42 freddy77 Exp $
 dnl If you're trying to create a new configure test, try
 dnl
 dnl 	http://autogen.sourceforge.net/conftest.html
@@ -15,7 +15,7 @@ dnl ------------------------------------------------------------
 AC_INIT(FreeTDS, 0.83.dev.esyscmd(echo -n $(date +"%Y%m%d")))
 AC_CONFIG_SRCDIR(src/dblib/dblib.c)
 AC_PREREQ(2.53)
-AC_REVISION($Revision: 1.39 $)
+AC_REVISION($Revision: 1.40 $)
 
 AM_INIT_AUTOMAKE
 AC_CONFIG_HEADERS(include/config.h)
@@ -169,6 +169,9 @@ case $host in
 		fi
 	fi
 
+	# check for _xpg_ functions
+	AC_CHECK_FUNCS([_xpg_accept _xpg_getpeername _xpg_getsockname _xpg_getsockopt _xpg_recvfrom \
+	__accept __getpeername __getsockname __getsockopt __recvfrom])
 	AM_CONDITIONAL(MINGW32, false)
 	;;
 *)
diff --git a/include/tds_sysdep_private.h b/include/tds_sysdep_private.h
index 4089fd4..47c5126 100644
--- a/include/tds_sysdep_private.h
+++ b/include/tds_sysdep_private.h
@@ -20,7 +20,7 @@
 #ifndef _tds_sysdep_private_h_
 #define _tds_sysdep_private_h_
 
-/* $Id: tds_sysdep_private.h,v 1.27 2009/01/16 20:27:57 jklowden Exp $ */
+/* $Id: tds_sysdep_private.h,v 1.28 2009/02/27 10:11:42 freddy77 Exp $ */
 
 #undef TDS_RCSID
 #if defined(__GNUC__) && __GNUC__ >= 3
@@ -160,6 +160,50 @@ typedef DWORD pid_t;
 # define SOCKLEN_T socklen_t
 #endif
 
+#define tds_accept      accept
+#define tds_getpeername getpeername
+#define tds_getsockopt  getsockopt
+#define tds_getsockname getsockname
+#define tds_recvfrom    recvfrom
+
+#if defined(__hpux__) && SIZEOF_VOID_P == 8 && SIZEOF_INT == 4
+# if HAVE__XPG_ACCEPT
+#  undef tds_accept
+#  define tds_accept _xpg_accept
+# elif HAVE___ACCEPT
+#  undef tds_accept
+#  define tds_accept __accept
+# endif
+# if HAVE__XPG_GETPEERNAME
+#  undef tds_getpeername
+#  define tds_getpeername _xpg_getpeername
+# elif HAVE___GETPEERNAME
+#  undef tds_getpeername
+#  define tds_getpeername __getpeername
+# endif
+# if HAVE__XPG_GETSOCKOPT
+#  undef tds_getsockopt
+#  define tds_getsockopt _xpg_getsockopt
+# elif HAVE___GETSOCKOPT
+#  undef tds_getsockopt
+#  define tds_getsockopt __getsockopt
+# endif
+# if HAVE__XPG_GETSOCKNAME
+#  undef tds_getsockname
+#  define tds_getsockname _xpg_getsockname
+# elif HAVE___GETSOCKNAME
+#  undef tds_getsockname
+#  define tds_getsockname __getsockname
+# endif
+# if HAVE__XPG_RECVFROM
+#  undef tds_recvfrom
+#  define tds_recvfrom _xpg_recvfrom
+# elif HAVE___RECVFROM
+#  undef tds_recvfrom
+#  define tds_recvfrom __recvfrom
+# endif
+#endif
+
 #ifndef TDS_SDIR_SEPARATOR
 #define TDS_SDIR_SEPARATOR "/"
 #endif /* !TDS_SDIR_SEPARATOR */
diff --git a/src/odbc/unittests/freeclose.c b/src/odbc/unittests/freeclose.c
index 3f56323..1098546 100644
--- a/src/odbc/unittests/freeclose.c
+++ b/src/odbc/unittests/freeclose.c
@@ -50,7 +50,7 @@
 
 #include "tds.h"
 
-static char software_version[] = "$Id: freeclose.c,v 1.9 2008/11/05 19:23:33 freddy77 Exp $";
+static char software_version[] = "$Id: freeclose.c,v 1.10 2009/02/27 10:11:42 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /* this crazy test test that we do not send too much prepare ... */
@@ -188,7 +188,7 @@ fake_thread_proc(void * arg)
 	memset(&sin, 0, sizeof(sin));
 	len = sizeof(sin);
 	alarm(30);
-	if ((fake_sock = accept(s, (struct sockaddr *) &sin, &len)) < 0) {
+	if ((fake_sock = tds_accept(s, (struct sockaddr *) &sin, &len)) < 0) {
 		perror("accept");
 		exit(1);
 	}
@@ -288,7 +288,7 @@ main(int argc, char **argv)
 	}
 
 	remote_addr_len = sizeof(remote_addr);
-	if (getpeername(last_socket, &remote_addr, &remote_addr_len)) {
+	if (tds_getpeername(last_socket, &remote_addr, &remote_addr_len)) {
 		fprintf(stderr, "Unable to get remote address\n");
 		return 1;
 	}
diff --git a/src/odbc/unittests/timeout3.c b/src/odbc/unittests/timeout3.c
index 27e81fd..b10e03e 100644
--- a/src/odbc/unittests/timeout3.c
+++ b/src/odbc/unittests/timeout3.c
@@ -40,7 +40,7 @@
 	test connection timeout
 */
 
-static char software_version[] = "$Id: timeout3.c,v 1.9 2008/11/06 15:56:39 freddy77 Exp $";
+static char software_version[] = "$Id: timeout3.c,v 1.10 2009/02/27 10:11:42 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void init_connect(void);
@@ -99,7 +99,7 @@ fake_thread_proc(void * arg)
 	memset(&sin, 0, sizeof(sin));
 	len = sizeof(sin);
 	alarm(30);
-	if ((fake_sock = accept(s, (struct sockaddr *) &sin, &len)) < 0) {
+	if ((fake_sock = tds_accept(s, (struct sockaddr *) &sin, &len)) < 0) {
 		perror("accept");
 		exit(1);
 	}
diff --git a/src/pool/user.c b/src/pool/user.c
index e2db9db..2fbd78a 100644
--- a/src/pool/user.c
+++ b/src/pool/user.c
@@ -48,7 +48,7 @@
 #include "tdssrv.h"
 #include "tdsstring.h"
 
-TDS_RCSID(var, "$Id: user.c,v 1.33 2008/11/15 09:57:06 freddy77 Exp $");
+TDS_RCSID(var, "$Id: user.c,v 1.34 2009/02/27 10:11:42 freddy77 Exp $");
 
 static TDS_POOL_USER *pool_user_find_new(TDS_POOL * pool);
 static int pool_user_login(TDS_POOL * pool, TDS_POOL_USER * puser);
@@ -109,7 +109,7 @@ pool_user_create(TDS_POOL * pool, TDS_SYS_SOCKET s, struct sockaddr_in *sin)
 
 	fprintf(stderr, "accepting connection\n");
 	len = sizeof(*sin);
-	if (TDS_IS_SOCKET_INVALID(fd = accept(s, (struct sockaddr *) sin, &len))) {
+	if (TDS_IS_SOCKET_INVALID(fd = tds_accept(s, (struct sockaddr *) sin, &len))) {
 		perror("accept");
 		return NULL;
 	}
diff --git a/src/server/login.c b/src/server/login.c
index 976beed..db0163d 100644
--- a/src/server/login.c
+++ b/src/server/login.c
@@ -58,7 +58,7 @@
 #include "tdssrv.h"
 #include "tdsstring.h"
 
-static char software_version[] = "$Id: login.c,v 1.53 2008/11/14 16:34:22 freddy77 Exp $";
+static char software_version[] = "$Id: login.c,v 1.54 2009/02/27 10:11:43 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 unsigned char *
@@ -100,7 +100,7 @@ tds_listen(TDSCONTEXT * ctx, int ip_port)
 	}
 	listen(s, 5);
 	len = sizeof(sin);
-	fd = accept(s, (struct sockaddr *) &sin, &len);
+	fd = tds_accept(s, (struct sockaddr *) &sin, &len);
 	if (TDS_IS_SOCKET_INVALID(fd)) {
 		CLOSESOCKET(s);
 		perror("accept");
diff --git a/src/tds/net.c b/src/tds/net.c
index 5fd6ebb..926627d 100644
--- a/src/tds/net.c
+++ b/src/tds/net.c
@@ -103,7 +103,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: net.c,v 1.86 2009/02/07 00:26:22 jklowden Exp $");
+TDS_RCSID(var, "$Id: net.c,v 1.87 2009/02/27 10:11:43 freddy77 Exp $");
 
 #undef USE_POLL
 #if defined(HAVE_POLL_H) && defined(HAVE_POLL)
@@ -299,7 +299,7 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 	/* check socket error */
 	optlen = sizeof(len);
 	len = 0;
-	if (getsockopt(tds->s, SOL_SOCKET, SO_ERROR, (char *) &len, &optlen) != 0) {
+	if (tds_getsockopt(tds->s, SOL_SOCKET, SO_ERROR, (char *) &len, &optlen) != 0) {
 		tds->oserr = sock_errno;
 		tdsdump_log(TDS_DBG_ERROR, "getsockopt(2) failed: %s\n", strerror(sock_errno));
 		goto not_available;

